searchNodes=[{"doc":"ExSieve is meant to be used by a module implementing Ecto.Repo behaviour.When used, optional configuration parameters can be provided. For details about cofngiuration parameters see ExSieve.Config.t/0.defmodule MyApp.Repo do use Ecto.Repo, otp_app: :my_app use ExSieve end defmodule MyApp.Repo do use Ecto.Repo, otp_app: :my_app use ExSieve, ignore_erros: true endWhen use is called, a ExSieve.filter/3 function is defined in the Repo.This function can and used for filtering entries based on query parametersdef index(conn, %{&quot;q&quot;=&gt; params}) do posts = MyApp.Repo.filter(MyApp.Post, params) render conn, :index, posts: posts endOptions can be overridden by setting on per-schema basis (see ExSieve.Schema) or on single ExSieve.filter/3 calls.ExamplesIn the following we assume these schemas are defined in your application:defmodule MyApp.Post do use Ecto.Schema schema &quot;posts&quot; do has_many :comments, MyApp.Comment field :title field :body field :published, :boolean timestamps() end end defmodule MyApp.Comment do use Ecto.Schema schema &quot;comments&quot; do belongs_to :post, MyApp.Post field :body timestamps() end endSimple queryGiven this json representation of the query{ &quot;m&quot;: &quot;or&quot;, &quot;id_in&quot;: [1, 2], &quot;title_and_body_cont&quot;: &quot;text&quot;, &quot;comments_body_eq&quot;: &quot;body&quot;, &quot;s&quot;: [&quot;title desc&quot;, &quot;inserted_at asc&quot;] }the following SQL query is sent to the databaseSELECT posts.* FROM posts INNER JOIN comments ON posts.id = comments.post_id WHERE posts.id IN (1, 2) OR (posts.title ILIKE '%text%' AND posts.body ILIKE '%text%') OR comments.body == &quot;body&quot; ORDER BY posts.title DESC, posts.inserted_at ASC;Grouping queriesQuery fields can be nested for obtaining more advanced filters.Given this json representation of the query{ &quot;m&quot;: &quot;and&quot;, &quot;id_in&quot;: [1, 2], &quot;g&quot;: [ { &quot;m&quot;: &quot;or&quot;, &quot;c&quot;: { &quot;title_and_body_cont&quot;: &quot;text&quot;, &quot;comments_body_eq&quot;: &quot;body&quot; } } ], &quot;s&quot;: [&quot;title desc&quot;, &quot;inserted_at asc&quot;] }the following SQL query is sent to the databaseSELECT posts.* FROM posts INNER JOIN comments ON posts.id = comments.post_id WHERE posts.id IN (1, 2) AND ( (posts.title ILIKE '%text%' AND posts.body ILIKE '%text%') OR comments.body == &quot;body&quot;) ORDER BY posts.title DESC, posts.inserted_at ASC;Supported predicatesBase predicateseqnot_eqcontnot_contltlteqgtgteqinnot_inmatchesdoes_not_matchstartnot_startendnot_endtruenot_truefalsenot_falsepresentblanknullnot_nullComposite predicateseq_anynot_eq_allcont_allcont_anynot_cont_allnot_cont_anymatches_allmatches_anydoes_not_match_alldoes_not_match_anystart_anynot_start_allend_anynot_end_allCombinatorsorandCustom predicatesExSieve allows to define user-specific predicates.These predicates must be defined at compile time with the :custom_predicates key of the :ex_sieve application environment. It should be a keyword list that maps predicate_names (atom) to Ecto.Query.API.fragment/1 strings.config :ex_sieve, custom_predicates: [ has_key: &quot;? \\\\? ?&quot;, less_than_6: &quot;? &lt; 6&quot;, key_is: &quot;(? -&gt;&gt; ?) = ?&quot; ]The first argument given to the fragment is the field while next ones are the values given in the query string.Given this json representation of the query{ &quot;metadata_has_key&quot;: &quot;tag&quot;, &quot;score_less_than_6&quot;: true, &quot;metadata_key_is: [&quot;status&quot;, &quot;approved&quot;] }the following SQL query is sent to the databaseSELECT posts.* FROM posts WHERE posts.metadata ? 'tag' AND posts.score &lt; 6 AND (posts.metadata -&gt;&gt; 'status') = 'approved';Predicate aliasesAliases to built-in and custom predicates can be configured in using the :predicate_aliases key in :ex_sieve application environment. It should be a keyword list that maps an alias name (atom) to a predicate (atom).Aliases for not existent predicates are silently discarded, multiple aliases can be defined for the same predicate.config :ex_sieve, custom_predicates: [ has_key: &quot;? \\\\? ?&quot; ], predicate_aliases: [ m: :matches, hk: :has_key ]NotesLIKE injectionLIKE queries can suffer of LIKE injection attacks.For this reason all predicates which result in a LIKE query (cont, not_cont, start, not_start, end, not_end and their composite predicates) are properly escaped.Some exceptions are matches, does_not_match and their composite predicates that allows %, _ and \\ chars in the value. You should be very careful when allowing an external user to use these predicates.","ref":"ExSieve.html","title":"ExSieve","type":"behaviour"},{"doc":"Filters the given query based on params.Returns the query with the added filters or an error tuple.For details about available options see ExSieve.Config.t/0.In order to avoid duplicated joins being sent to database only named bindings should be used and the binding name should correspond to the related table one.ExamplesRepo.filter(User, %{&quot;name_cont&quot; =&gt; &quot;foo&quot;}) Repo.filter(from(u in User), %{&quot;name_cont&quot; =&gt; &quot;foo&quot;}) Repo.filter(from(u in User), %{&quot;name_cont&quot; =&gt; &quot;foo&quot;}) User |&gt; join(:inner, [u], p in assoc(u, :posts), as: :posts) |&gt; preload(:posts) |&gt; Repo.filter(%{&quot;name_cont&quot; =&gt; &quot;foo&quot;}) # WARNING: this will result in a duplicated join User |&gt; join(:inner, [u], p in assoc(u, :posts), as: :posts_dup) |&gt; Repo.filter(%{&quot;posts_title_cont&quot; =&gt; &quot;foo&quot;})","ref":"ExSieve.html#c:filter/3","title":"ExSieve.filter/3","type":"callback"},{"doc":"","ref":"ExSieve.html#t:error/0","title":"ExSieve.error/0","type":"type"},{"doc":"","ref":"ExSieve.html#t:result/0","title":"ExSieve.result/0","type":"type"},{"doc":"Struct with ExSieve configuration options.","ref":"ExSieve.Config.html","title":"ExSieve.Config","type":"module"},{"doc":"ExSieve configuration options::ignore_errors - when true recoverable errors are ignored. Recoverable errors include for instance missing attribute or missing predicate, in that case the query is returned without taking into account the filter causing the error. Defaults to true:max_depth - the maximum level of nested relations that can be queried. Defaults to :full meaning no limit:only_predicates - a list of allowed predicates. The list can contain :basic and :composite, in that case all corresponding predicates are added to the list. When not given or when nil no limit is applied. Defaults to nil:except_predicates - a list of excluded predicates. The list can contain :basic and :composite, in that case all corresponding predicates are added to the list. When not given or when nil no limit is applied. If both :only_predicates and :except_predicates are given :only_predicates takes precedence and :except_predicates is ignored. Defaults to nil","ref":"ExSieve.Config.html#t:t/0","title":"ExSieve.Config.t/0","type":"type"},{"doc":"ExSieve.Schema is meant to be used by modules using Ecto.Schema.When used, optional configuration parameters specific for the schema can be provided. For details about cofngiuration parameters see ExSieve.Config.t/0.defmodule MyApp.User do use ExSieve.Schema end defmodule MyApp.USer do use ExSieve.Schema, max_depth: 0 endWhen using ExSieve.Schema, the list of not filterable schema fields can be specified with the @ex_sieve_not_filterable_fields module attribute.defmodule MyApp.User do use Ecto.Schema use ExSieve.Schema @ex_sieve_not_filterable_fields [:name, :inserted_at, :comments] schema &quot;users&quot; do has_many :comments, ExSieve.Comment has_many :posts, ExSieve.Post field :name field :cash, Money.Ecto.Type timestamps() end endFilters for fields that are in the list are ignored (an error is returned if :ignore_errors is false). By default all fields are filterable.","ref":"ExSieve.Schema.html","title":"ExSieve.Schema","type":"module"}]